package com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.req_issue;

import static com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.linked_issue.연결이슈_처리.*;
import static com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.지라이슈_삭제처리.*;
import static com.arms.api.util.alm.지라유틸.*;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

import com.arms.api.issue.almapi.model.dto.요구사항_데이터;
import com.arms.api.issue.almapi.model.entity.AlmIssueEntity;
import com.arms.api.issue.almapi.model.vo.지라이슈_데이터;
import com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.abastract.지라이슈_엔티티_동기화_인터페이스;
import com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.linked_issue.연결이슈_처리;
import com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.subtask.하위이슈_삭제_처리;
import com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.지라이슈_데이터_컬렉션;
import com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.지라이슈_삭제처리;
import com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.지라이슈_엔티티_컬렉션;
import com.arms.api.util.alm.지라이슈_생성;
import com.arms.egovframework.javaservice.esframework.esquery.EsQuery;
import com.arms.egovframework.javaservice.esframework.esquery.EsQueryBuilder;
import com.arms.egovframework.javaservice.esframework.esquery.filter.TermsQueryFilter;
import com.arms.egovframework.javaservice.esframework.model.dto.기본_검색_요청;
import com.arms.egovframework.javaservice.esframework.repository.EsCommonRepositoryWrapper;

import lombok.extern.slf4j.Slf4j;

@Slf4j
public class 요구사항_이슈_처리 extends EsCommonRepositoryWrapper<AlmIssueEntity> {

	private final 지라이슈_엔티티_컬렉션 지라이슈_엔티티_컬렉션 = new 지라이슈_엔티티_컬렉션(new ArrayList<>());

	private final 지라이슈_데이터 지라이슈_데이터;

	private final 요구사항_데이터 요구사항_데이터;

	private 요구사항_이슈_처리(요구사항_데이터 요구사항_데이터) throws Exception {

		this.지라이슈_데이터 = 요구사항_데이터.지라이슈_데이터_가져오기();

		log.info("요청키::{}, ALM 조회 데이터 정보::{}", 요구사항_데이터.get이슈_키(),this.지라이슈_데이터);

		if (ALM_요구사항_존재_하지않으면()) {
			요구사항_이슈_삭제_처리(요구사항_데이터);
		}

		if (ALM_요구사항_존재_하면() && 요구사항_데이터.지라이슈_이동을_했다면(this.지라이슈_데이터.getKey())) {

			요구사항_이슈_삭제_처리(요구사항_데이터);

			요구사항_데이터.지라이슈_이동으로_키_변경(this.지라이슈_데이터.getKey());

			log.info("신규 요청키::{}", 요구사항_데이터.get이슈_키());
		}

		this.요구사항_데이터 = 요구사항_데이터;

	}

	public static 요구사항_이슈_처리 요구사항_이슈_저장_처리(요구사항_데이터 요구사항_데이터) throws Exception {
		요구사항_이슈_처리 요구사항_이슈_처리 = new 요구사항_이슈_처리(요구사항_데이터);
		요구사항_이슈_처리.이슈_처리();
		요구사항_이슈_처리.지라이슈_데이터에_존재하지_않는_요구사항_이슈_엔티티_삭제_적용();
		return 요구사항_이슈_처리;
	}

	public static 요구사항_이슈_처리 증분_요구사항_이슈_저장_처리(요구사항_데이터 요구사항_데이터) throws Exception {
		요구사항_이슈_처리 증분_요구사항_이슈_저장_처리 = new 요구사항_이슈_처리(요구사항_데이터);
		증분_요구사항_이슈_저장_처리.증분이슈_처리();
		증분_요구사항_이슈_저장_처리.지라이슈_데이터에_존재하지_않는_요구사항_이슈_엔티티_삭제_적용();
		return 증분_요구사항_이슈_저장_처리;
	}

	private void 요구사항_이슈_삭제_처리(요구사항_데이터 요구사항_데이터) {

		this.지라이슈_일괄_삭제_적용(
				new 지라이슈_엔티티_컬렉션(this.요구사항_검색하기(요구사항_데이터)).getAlmIssueEntity_목록()
		);

		List<AlmIssueEntity> 연결이슈_하위이슈_목록 = this.연결_및_하위_이슈목록_검색하기(요구사항_데이터);
		List<AlmIssueEntity> 요구사항_이슈_제외_필터링 = 연결이슈_하위이슈_목록.stream()
				.filter(엔티티 -> 엔티티.getIsReq().equals(Boolean.FALSE))
				.collect(Collectors.toList());

		this.지라이슈_일괄_삭제_적용(
				new 지라이슈_엔티티_컬렉션(요구사항_이슈_제외_필터링).getAlmIssueEntity_목록()
		);
	}

	private void 지라이슈_데이터에_존재하지_않는_요구사항_이슈_엔티티_삭제_적용(){

		지라이슈_데이터_컬렉션 지라이슈_데이터_컬렉션 = new 지라이슈_데이터_컬렉션(List.of());

		if(ALM_요구사항_존재_하면()){
			지라이슈_데이터_컬렉션 = new 지라이슈_데이터_컬렉션(List.of(지라이슈_데이터));
		}

		지라이슈_엔티티_컬렉션 지라이슈_엔티티_컬렉션
				= new 지라이슈_엔티티_컬렉션(this.요구사항_검색하기(요구사항_데이터));

		this.지라이슈_일괄_삭제_적용(
				지라이슈_데이터_컬렉션
						.지라이슈_데이터에_존재하지_않는_지라이슈_목록(지라이슈_엔티티_컬렉션)
						.getAlmIssueEntity_목록()
		);
	}

	private void 지라이슈_일괄_삭제_적용(List<AlmIssueEntity> 요구사항_서브테스크_삭제_목록값){
		요구사항_서브테스크_삭제_목록값.forEach(
				지라이슈_삭제처리::지라이슈_삭제_적용
		);
		지라이슈_엔티티_컬렉션.엔티티_목록_추가(요구사항_서브테스크_삭제_목록값);
	}

	private void 이슈_처리() throws Exception {
		if (ALM_요구사항_존재_하면()) {
			preModifyAddToList();
		}
		else {
			요구사항과_하위이슈_삭제처리();
		}
	}

	private void 증분이슈_처리() throws Exception {
		if (ALM_요구사항_존재_하면()) {
			incrementalReqIssueToEntity();
		}
		else {
			요구사항과_하위이슈_삭제처리();
		}
	}

	private void incrementalReqIssueToEntity() throws Exception {
		if (요구사항_데이터.getStartDate()!=null&&요구사항_데이터.getEndDate()!=null) {
			preModifyAddToList();
		}else if (전일_업데이트여부(지라이슈_데이터.getFields().getUpdated())) {
			preModifyAddToList();
		}
	}

	private void preModifyAddToList() throws Exception {
		지라이슈_엔티티_컬렉션.엔티티_추가(this.요구사항_이슈_엔티티_생성());

		if (지라이슈_데이터.ALM_프로젝트_변경했다면(요구사항_데이터)) {
			요구사항과_하위이슈_삭제처리();
		}
		;
	}

	private void 요구사항과_하위이슈_삭제처리() {

		this.지라이슈_요구사항_연결_끊고_삭제_적용(
			this.이슈_조회하기(요구사항_데이터.조회조건_아이디())
		);

		지라이슈_엔티티_동기화_인터페이스 지라이슈_엔티티_동기화_인터페이스 = new 하위이슈_삭제_처리(요구사항_데이터);

		지라이슈_엔티티_컬렉션.엔티티_목록_추가(지라이슈_엔티티_동기화_인터페이스.수집된_지라이슈_목록_가져오기());
	}

	private void 지라이슈_요구사항_연결_끊고_삭제_적용(AlmIssueEntity 지라이슈_엔티티값){
		지라이슈_엔티티_컬렉션.엔티티_추가(지라이슈_삭제_적용(지라이슈_엔티티값));
	}

	private AlmIssueEntity 요구사항_이슈_엔티티_생성() throws Exception {
		연결이슈_처리 연결이슈_처리 = 연결이슈_처리(요구사항_데이터);
		return 지라이슈_생성.ELK_데이터로_변환(
				요구사항_데이터.get지라서버_아이디()
				, 지라이슈_데이터
				, true
				, null
				, 요구사항_데이터.get제품서비스_아이디()
				, 요구사항_데이터.get제품서비스_버전들()
				, 요구사항_데이터.getCReqLink()
				, 연결이슈_처리.연결이슈_아이디_배열_가져오기()
				, 요구사항_데이터.getCReqProperty()
				, 지라이슈_데이터.getRawData()
		);
	}

	private boolean ALM_요구사항_존재_하지않으면(){
		return !ALM_요구사항_존재_하면();
	}

	private boolean ALM_요구사항_존재_하면(){
		return 지라이슈_데이터 != null;
	}

	public List<AlmIssueEntity> get지라이슈_엔티티_목록(){
		return 지라이슈_엔티티_컬렉션.getAlmIssueEntity_목록();
	}

	private AlmIssueEntity 이슈_조회하기(String 조회조건_아이디){

		AlmIssueEntity almIssueEntity = this.findRecentDocById(조회조건_아이디);

		if (almIssueEntity == null) {
			return null;
		}

		return almIssueEntity;
	}

	private List<AlmIssueEntity> 연결_및_하위_이슈목록_검색하기(요구사항_데이터 요구사항_데이터) {

		EsQuery esQuery = new EsQueryBuilder()
				.bool(
						new TermsQueryFilter("parentReqKey",요구사항_데이터.get이슈_키())
						,new TermsQueryFilter("jira_server_id",요구사항_데이터.get지라서버_아이디())
				);

		기본_검색_요청 기본_검색_요청 = new 기본_검색_요청();
		기본_검색_요청.setEsQuery(esQuery);

		return this.findRecentHits(기본_검색_요청).toDocs();

	}


	private List<AlmIssueEntity> 요구사항_검색하기(요구사항_데이터 요구사항_데이터) {

		EsQuery esQuery = new EsQueryBuilder()
				.bool(
						new TermsQueryFilter("key", 요구사항_데이터.get이슈_키())
						,new TermsQueryFilter("jira_server_id", 요구사항_데이터.get지라서버_아이디())
				);

		기본_검색_요청 기본_검색_요청 = new 기본_검색_요청();
		기본_검색_요청.setEsQuery(esQuery);

		try {
            return this.findRecentHits(기본_검색_요청).toDocs();
		}
		catch (Exception e) {
			return Collections.emptyList();
		}
	}

}
