package com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.subtask;

import java.util.ArrayList;
import java.util.List;

import com.arms.api.issue.almapi.model.dto.요구사항_데이터;
import com.arms.api.issue.almapi.model.entity.AlmIssueEntity;
import com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.abastract.지라이슈_엔티티_동기화_인터페이스;
import com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.지라이슈_삭제처리;
import com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.지라이슈_엔티티_컬렉션;
import com.arms.egovframework.javaservice.esframework.esquery.EsQuery;
import com.arms.egovframework.javaservice.esframework.esquery.EsQueryBuilder;
import com.arms.egovframework.javaservice.esframework.esquery.filter.TermsQueryFilter;
import com.arms.egovframework.javaservice.esframework.model.dto.기본_검색_요청;
import com.arms.egovframework.javaservice.esframework.repository.EsCommonRepositoryWrapper;

import lombok.extern.slf4j.Slf4j;


@Slf4j
public class 하위이슈_삭제_처리 extends EsCommonRepositoryWrapper<AlmIssueEntity> implements 지라이슈_엔티티_동기화_인터페이스 {

	private final 지라이슈_엔티티_컬렉션 지라이슈_엔티티_저장_목록 = new 지라이슈_엔티티_컬렉션(new ArrayList<>());

	public 하위이슈_삭제_처리(요구사항_데이터 요구사항_데이터) {
		List<AlmIssueEntity> 하위이슈_목록 = this.연결_및_하위_이슈목록_검색하기(요구사항_데이터);
		하위이슈_목록.forEach(
			지라이슈_삭제처리::지라이슈_삭제_적용
		);

		지라이슈_엔티티_저장_목록.엔티티_목록_추가(하위이슈_목록);
	}

	@Override
	public List<AlmIssueEntity> 수집된_지라이슈_목록_가져오기(){
		return 지라이슈_엔티티_저장_목록.getAlmIssueEntity_목록();
	}


	private List<AlmIssueEntity> 연결_및_하위_이슈목록_검색하기(요구사항_데이터 요구사항_데이터) {

		EsQuery esQuery = new EsQueryBuilder()
				.bool(
						 new TermsQueryFilter("parentReqKey",요구사항_데이터.get이슈_키())
						,new TermsQueryFilter("jira_server_id",요구사항_데이터.get지라서버_아이디())
				);
		기본_검색_요청 기본_검색_요청 = new 기본_검색_요청();
		기본_검색_요청.setEsQuery(esQuery);

		return this.findRecentHits(기본_검색_요청).toDocs();

	}


}
