package com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.subtask;

import static com.arms.config.ApplicationContextProvider.*;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import com.arms.api.issue.almapi.model.dto.요구사항_데이터;
import com.arms.api.issue.almapi.model.entity.AlmIssueEntity;
import com.arms.api.issue.almapi.model.vo.지라이슈_데이터;
import com.arms.api.issue.almapi.service.이슈전략_호출;
import com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.지라이슈_데이터_컬렉션;
import com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.지라이슈_삭제처리;
import com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.지라이슈_엔티티_컬렉션;
import com.arms.api.util.alm.지라이슈_생성;
import com.arms.egovframework.javaservice.esframework.esquery.EsQuery;
import com.arms.egovframework.javaservice.esframework.esquery.EsQueryBuilder;
import com.arms.egovframework.javaservice.esframework.esquery.filter.TermsQueryFilter;
import com.arms.egovframework.javaservice.esframework.model.dto.기본_검색_요청;
import com.arms.egovframework.javaservice.esframework.repository.EsCommonRepositoryWrapper;

public class 하위이슈_처리 extends EsCommonRepositoryWrapper<AlmIssueEntity> {

    private final 지라이슈_엔티티_컬렉션 지라이슈_엔티티_컬렉션 = new 지라이슈_엔티티_컬렉션(new ArrayList<>());

    private final List<지라이슈_데이터> 지라이슈_데이터_하위이슈_목록;

    private final 요구사항_데이터 요구사항_데이터;

    private 하위이슈_처리(요구사항_데이터 요구사항_데이터) throws Exception {
        this.요구사항_데이터 = 요구사항_데이터;
        this.지라이슈_데이터_하위이슈_목록 = getBean(이슈전략_호출.class).서브테스크_가져오기(요구사항_데이터);
    }

    public static 하위이슈_처리 하위이슈_처리(요구사항_데이터 요구사항_데이터) throws Exception {
        하위이슈_처리 하위이슈_처리 = new 하위이슈_처리(요구사항_데이터);
        하위이슈_처리.지라이슈_데이터에_존재하지_않는_지라이슈_엔티티_삭제_적용();
        하위이슈_처리.지라이슈_엔티티_하위이슈_목록_적용();
        return 하위이슈_처리;
    }

    public static 하위이슈_처리 증분_하위이슈_처리(요구사항_데이터 요구사항_데이터) throws Exception {
        하위이슈_처리 증분_하위이슈_처리 = new 하위이슈_처리(요구사항_데이터);
        증분_하위이슈_처리.지라이슈_데이터에_존재하지_않는_지라이슈_엔티티_삭제_적용();
        증분_하위이슈_처리.지라이슈_엔티티_필드적용_및_목록추가(getBean(이슈전략_호출.class).증분서브테스크_가져오기(요구사항_데이터));
        return 증분_하위이슈_처리;
    }

    public List<AlmIssueEntity> get지라이슈_엔티티_저장_목록() {
        return 지라이슈_엔티티_컬렉션.getAlmIssueEntity_목록();
    }

    private void 지라이슈_데이터에_존재하지_않는_지라이슈_엔티티_삭제_적용() {
        지라이슈_데이터_컬렉션 지라이슈_데이터_컬렉션 = new 지라이슈_데이터_컬렉션(지라이슈_데이터_하위이슈_목록);
        this.지라이슈_일괄_삭제_적용(
            지라이슈_데이터_컬렉션.지라이슈_데이터에_존재하지_않는_지라이슈_목록(
                    new 지라이슈_엔티티_컬렉션(this.연결_및_하위_이슈목록_검색하기(요구사항_데이터)))
                                .getAlmIssueEntity_목록()
        );
    }

    private void 지라이슈_일괄_삭제_적용(List<AlmIssueEntity> 요구사항_서브테스크_삭제_목록값){
        요구사항_서브테스크_삭제_목록값.forEach(
                지라이슈_삭제처리::지라이슈_삭제_적용
        );
        지라이슈_엔티티_컬렉션.엔티티_목록_추가(요구사항_서브테스크_삭제_목록값);
    }

    private void 지라이슈_엔티티_하위이슈_목록_적용() {
        this.지라이슈_엔티티_필드적용_및_목록추가(지라이슈_데이터_하위이슈_목록);
    }

    private void 지라이슈_엔티티_필드적용_및_목록추가(List<지라이슈_데이터> 서브테스크_목록) {
        List<AlmIssueEntity> 지라이슈_엔티티들 = 서브테스크_목록
                .stream()
                .map(ALM_하위이슈 -> 지라이슈_생성.ELK_데이터로_변환(
                        요구사항_데이터.get지라서버_아이디()
                        , ALM_하위이슈
                        , false
                        , 요구사항_데이터.get이슈_키()
                        , 요구사항_데이터.get제품서비스_아이디()
                        , 요구사항_데이터.get제품서비스_버전들()
                        , 요구사항_데이터.getCReqLink()
                        , 요구사항_데이터.getCReqProperty()
                        , ALM_하위이슈.getRawData()
                )).collect(Collectors.toList());

        지라이슈_엔티티_컬렉션.엔티티_목록_추가(지라이슈_엔티티들);
    }

    private List<AlmIssueEntity> 연결_및_하위_이슈목록_검색하기(요구사항_데이터 요구사항_데이터) {

        EsQuery esQuery = new EsQueryBuilder()
                .bool(
                        new TermsQueryFilter("parentReqKey",요구사항_데이터.get이슈_키())
                        ,new TermsQueryFilter("jira_server_id",요구사항_데이터.get지라서버_아이디())
                );

        기본_검색_요청 기본_검색_요청 = new 기본_검색_요청();
        기본_검색_요청.setEsQuery(esQuery);

        return this.findRecentHits(기본_검색_요청).toDocs();

    }
}
