package com.arms.api.serverinfo.controller;

import com.arms.api.serverinfo.model.서버정보_데이터;
import com.arms.api.serverinfo.model.서버정보_엔티티;
import com.arms.api.serverinfo.service.서버정보_서비스;
import com.arms.egovframework.javaservice.esframework.erros.response.ErrorCode;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.scheduling.annotation.Async;
import org.springframework.web.bind.annotation.*;

import java.util.Map;
import java.util.concurrent.CompletableFuture;

@Slf4j
@RestController
@RequestMapping("/engine/serverinfo")
public class 서버정보_컨트롤러 {

    @Autowired
    private 서버정보_서비스 서버정보_서비스;

    @ResponseBody
    @RequestMapping(
            value = {""},
            method = {RequestMethod.POST}
    )
    public 서버정보_엔티티 서버정보_저장_또는_수정(@RequestBody 서버정보_데이터 서버정보_데이터) {

        if (서버정보_데이터 == null) {
            throw new IllegalArgumentException(ErrorCode.서버정보_오류.getErrorMsg());
        }
        else if (서버정보_데이터.getConnectId() == null) {
            throw new IllegalArgumentException(ErrorCode.서버_ID정보_오류.getErrorMsg());
        }
        else if (StringUtils.isBlank(서버정보_데이터.getUri())) {
            throw new IllegalArgumentException(ErrorCode.서버_URI정보_오류.getErrorMsg());
        }
        else if (StringUtils.isBlank(서버정보_데이터.getUserId())) {
            throw new IllegalArgumentException(ErrorCode.서버_ID정보_오류.getErrorMsg());
        }
        else if (StringUtils.isBlank(서버정보_데이터.getPasswordOrToken())) {
            throw new IllegalArgumentException(ErrorCode.서버_PW_또큰_API토큰정보_오류.getErrorMsg());
        }
        else if (StringUtils.isBlank(서버정보_데이터.getType())) {
            throw new IllegalArgumentException(ErrorCode.서버유형_정보오류.getErrorMsg());
        }

        log.info("[서버정보_컨트롤러 :: 서버정보_저장_또는_수정] :: " + 서버정보_데이터.toString());

        return 서버정보_서비스.서버정보_저장_또는_수정(서버정보_데이터);
    }

    @ResponseBody
    @RequestMapping(
            value = {"/backup/scheduler"},
            method = {RequestMethod.POST}
    )
    @Async
    public CompletableFuture<Iterable<서버정보_엔티티>> 서버정보백업_스케줄러() {

        log.info("[서버정보_컨트롤러 :: 서버정보백업_스케줄러]");

        return 서버정보_서비스.서버정보백업_스케줄러();
    }

    /*
    * 삭제 관련 차후 설계 후 개발 진행
    * */
    @ResponseBody
    @RequestMapping(
            value = {""},
            method = {RequestMethod.DELETE}
    )
    public 서버정보_데이터 서버정보_삭제(@RequestBody 서버정보_데이터 서버정보_데이터) throws Exception {

        if (서버정보_데이터 == null || 서버정보_데이터.getConnectId() == null) {
            throw new Exception("삭제 요청 데이터가 없습니다.");
        }

        log.info("[서버정보_컨트롤러 :: 서버정보_삭제] :: " + 서버정보_데이터.getConnectId());

        서버정보_서비스.서버정보_삭제하기(서버정보_데이터.getConnectId());

        return 서버정보_데이터;

    }

    @ResponseBody
    @RequestMapping(
            value = {"/serverTypeMap"},
            method = {RequestMethod.GET}
    )
    public ResponseEntity<Map<String, String>> 서버_연결아이디_유형정보_맵_조회() {

        log.info("[서버정보_컨트롤러 :: 서버_연결아이디_유형정보_맵_조회]");

        Map<String, String> 서버_연결아이디_유형_맵 = 서버정보_서비스.서버_연결아이디_유형_맵();
        return ResponseEntity.ok(서버_연결아이디_유형_맵);
    }
}
