package com.arms.egovframework.javaservice.esframework.config;

import java.util.Map;

import org.springframework.core.MethodParameter;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.support.WebDataBinderFactory;
import org.springframework.web.context.request.NativeWebRequest;
import org.springframework.web.method.support.HandlerMethodArgumentResolver;
import org.springframework.web.method.support.ModelAndViewContainer;

import lombok.extern.slf4j.Slf4j;

@Slf4j
public class PathVariableResolver implements HandlerMethodArgumentResolver {
	@Override
	public boolean supportsParameter(MethodParameter parameter) {
		boolean assignableFrom = Map.class.isAssignableFrom(parameter.getParameterType());
		System.out.println(assignableFrom);
		return true;
	}

	@Override
	public Object resolveArgument(MethodParameter parameter, ModelAndViewContainer mavContainer,
		NativeWebRequest webRequest, WebDataBinderFactory binderFactory) throws Exception {
		log.info("요청 리졸버 입니다.");
		log.info("pathVariables:{}",webRequest.getAttribute("org.springframework.web.servlet.View.pathVariables",NativeWebRequest.SCOPE_REQUEST));
		return null;
	}

}
